<?php
namespace app\admin\model;

class AdminMenu extends Base
{
//设置字段信息
    protected $schema = [
        'id'       =>'bigint',//
        'menu_name'       =>'varchar',//菜单名称
        'menu_code'       =>'varchar',//菜单code
        'menu_img'       =>'varchar',//菜单图片
        'menu_route'       =>'varchar',//菜单路由
        'menu_url'       =>'varchar',//菜单地址
        'menu_api'       =>'varchar',//接口地址
        'pid'       =>'bigint',//父级id
        'is_show'       =>'int',//是否禁用
        'is_private'       =>'int',//是否私有
        'level'       =>'tinyint',//菜单等级,0公共,1超管,2业务公司,3供应商
        'is_display'       =>'int',//是否展示
        'weight'       =>'double',//权重
        'status'       =>'int',//状态
        'is_del'       =>'int',//是否删除
        'addtime'       =>'datetime',//
        'updatetime'       =>'datetime',//
        'menu_type'       =>'tinyint',//1菜单2 页面

    ];
    
    public static function GetMenu($menuid){
    	$info=self::where(["id"=>$menuid,"is_del"=>0])->findOrEmpty();
    	if($info->pid>0){
    		$paren = self::where(['pid'=>$info->pid,'is_del'=>0])->findOrEmpty();
    	}
    	return ["menu_name"=>$info->menu_name,"parent_name"=>$paren->menu_name??"","parent_id"=>$info->pid];
    }
   public function ActionInfo(){
    	return $this->hasMany(Action::class,"action_id")->where(["is_del"=>0]);
   }
   public static function GetMenuBySecod($menuid,$result=[]){
       $menuArr = self::where(['id'=>$menuid])->findOrEmpty();

        if(!$menuArr->isEmpty()){
            if($menuArr->pid>0)  self::GetMenuBySecod($menuArr->pid,$result);
            $result[] = ['id' => $menuid, 'rename' => $menuArr->menu_name, 'pid' => $menuArr->pid];
        }
        return $result;
    }

   public function GetMenuByActionArr($actionArr,$where=[]){
       $menuArr = Action::with(["ActionInfo"])->whereIn("id",$actionArr)->select();
       $tree=[];
       if(!$menuArr->isEmpty()){
            $menuid = [];
            foreach ($menuArr as $item){
                $menuid[$item->menuid][] =$item->action_code;
            }
            $menuArrId = array_unique(array_column($menuArr->toArray(),"menuid"));
            $menuAll=$this->where($where)->column("menu_name,menu_img,menu_route,is_display,status,pid","id");
            $tree=[];
          foreach ($menuArrId as $item){
              $this->buildForwardTree($item,$menuid[$item]??[],$menuAll,$tree);
          }
       }
        return $tree;
   }
  public function buildForwardTree($itemId, $node = [],&$items, &$menuTree=[]) {
        if(!isset($items[$itemId]))return;
            $node=$items[$itemId];
            if($node['pid']==0){
               if(!isset($menuTree[$itemId])){
                   $menuTree[$itemId]=$node;
               }
               $menuTree[$itemId]['child'][]=$node;
            }else{
                $node['action']=$node;
                $this->buildForwardTree($node['pid'],$node,$items);
            }
   }

}